(* portlandAppDelegate.ml     Application delegate for Portland
 *
 * Copyright (c) 2014 Psellos   http://psellos.com
 * Licensed under the MIT license:
 *     http://www.opensource.org/licenses/mit-license.php
 *)

class t =
object (self)
    inherit Wrappee.t

    val mutable theWindow: UiWindow.t option = None
    val mutable theVCD: Ui.portlandViewControllerD option = None

    method window =
        match theWindow with
        | None -> UiWindow.nil
        | Some window -> window

    method setWindow' window =
        theWindow <- Some window

    method applicationDidFinishLaunching' (appl: UiApplication.t) =
        let dev = UiDevice.currentDevice () in
        let vcd = self#window#rootViewController#delegate in
        theVCD <- Some vcd;
        ignore (NsTimer.scheduledTimer5 0.25 vcd "timerTick'" Wrappee.nil true);
        dev#beginGeneratingDeviceOrientationNotifications

    method applicationWillResignActive' (appl: UiApplication.t) =
        match theVCD with
        | None -> ()
        | Some vcd -> vcd#deactivate

    method applicationDidBecomeActive' (appl: UiApplication.t) =
        match theVCD with
        | None -> ()
        | Some vcd -> vcd#activate

end

let _ =
    let wrapped robjcv = let t = new t in t#setContainer robjcv; t in
    Callback.register "PortlandAppDelegate.wrapped" wrapped
